/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.ImageIcon;

class GameWindow extends JFrame {
	private Canvas cGame = new Canvas() {
		public void paint(Graphics g) {
			drawGame();
		}
	};

	private Canvas cHud = new Canvas() {
		public void paint(Graphics g) {
			drawHud();
		}
	};
	
	private JPanel pGame = new JPanel();
	private Canvas lDummy1 = new Canvas();
	private Canvas lDummy2 = new Canvas();
	private Canvas lDummy3 = new Canvas();
	private Canvas lDummy4 = new Canvas();
	
	private GUIUpdater guiUpdater;
	private GameLoop gameLoop;
	private JSLevel level;
	private Player player;
	private int type;
	private int lev;
	private Timer t;
	
	private boolean hd;
	
	private int menuNum;
	
	private int menuPart;
	private int menuPosX;
	private int menuPosY;
	private int lastPosX;
	
	private int size = 25;
	
	private int sx;
	private int sy;
	
	public GameWindow(Player p, boolean hd) {
		this.hd = hd;
		Dimension d = getToolkit().getScreenSize();
		sx = (int) d.getWidth();
		sy = (int) d.getHeight();
		
		if (hd) {
			if ((sx < 1250) || (sy < 1000)) {
				System.out.println("Screen resolution to low for HD. 1200px width and 1000px height requiered. Fallig back to normal version");
				hd = false;
			} else {
				size = 50;
			}
		}
		setTitle("Jippy Snake 7 (Vers. 2.0 RC2)");
		setIconImage( new ImageIcon("logo/logo_32.png").getImage() );
		
		player = p;
		setType(player.getLastMod());
		
		cGame.setSize(20*size,20*size);
		cHud.setSize(5*size,20*size);
		
		setLayout(new BorderLayout());
		pGame.setLayout(new BorderLayout());
		pGame.add(cGame, BorderLayout.CENTER);
		pGame.add(cHud, BorderLayout.EAST);
		pGame.setSize(25*size,20*size);
		add(pGame, BorderLayout.CENTER);
		
		cGame.setBackground(Color.BLACK);
		cHud.setBackground(Color.BLACK);
		
		lDummy1.setBackground(Color.BLACK);
		lDummy2.setBackground(Color.BLACK);
		lDummy3.setBackground(Color.BLACK);
		lDummy4.setBackground(Color.BLACK);
		lDummy1.setSize(sx, (sy-20*size)/2);
		lDummy2.setSize(sx, (sy-20*size)/2);
		lDummy3.setSize((sx-25*size)/2, 20*size);
		lDummy4.setSize((sx-25*size)/2, 20*size);
		add(lDummy1, BorderLayout.SOUTH);
		add(lDummy2, BorderLayout.NORTH);
		add(lDummy3, BorderLayout.WEST);
		add(lDummy4, BorderLayout.EAST);
		
		setUndecorated(true);
		setAlwaysOnTop(true);
		
		pack();
		setSize(sx,sy);
		
		setResizable(false);
		setVisible(true);
		cGame.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));
		cHud.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));
		lDummy1.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));
		lDummy2.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));
		lDummy3.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));
		lDummy4.setCursor (Toolkit.getDefaultToolkit().createCustomCursor(new BufferedImage(25,25,BufferedImage.TYPE_INT_ARGB),new Point(12,12),""));

		guiUpdater = new GUIUpdater(cGame, cHud, p, hd);
		loadLevel();
		
		cGame.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				if (e.getKeyCode() == KeyEvent.VK_UP)
					turn(0,-1);
				else if (e.getKeyCode() == KeyEvent.VK_DOWN)
					turn(0,1);
				else if (e.getKeyCode() == KeyEvent.VK_LEFT)
					turn(-1,0);
				else if (e.getKeyCode() == KeyEvent.VK_RIGHT)
					turn(1,0);
				else if (e.getKeyCode() == KeyEvent.VK_ESCAPE)
					menu();
				else if (e.getKeyCode() == KeyEvent.VK_ENTER)
					menuAct();
			}
		});
	}
	
	private void playPause() {
		gameLoop.setPaused(!gameLoop.getPaused());
	}

	private void menu() {
		gameLoop.setPaused(!gameLoop.getPaused());
		menuNum = 1+type;
		if (gameLoop.getPaused()) {
			menuPart = 0;
			menuPosX = level.getLevelNum()%10;
			menuPosY = level.getLevelNum()/10;
		}
		guiUpdater.setMenu(menuNum);
		//guiUpdater.updateMenu(0,menuPosX, menuPosY);
	}
	
	private void menuAct() {
		if (menuPart == 1) {
			if (menuPosX == 0) {
				//Menu for stats here!
				menuNum = 6;
				menuPosX = 1;
				menuPosY = 0;
				menuPart = 1;
				guiUpdater.setMenu(menuNum);
				guiUpdater.updateMenu(1,1,0);
			} else if (menuPosX == 1) {
				if (menuNum == 0) {
					player.setLongestSnake(level.getType(), level.getLevelNum(), level.getNumApples());
					player.savePlayer();
					System.exit(0);
				} else if (menuNum < 6) {
					menuPosY = 0;
					menuPosX = menuNum-1;
					menuPart = 0;
					menuNum = 0;
					guiUpdater.setMenu(menuNum);
					guiUpdater.updateMenu(0,menuPosX,0);
				} else {
					menuPosY = 0;
					menuPosX = 0;
					menuPart = 1;
					menuNum = 0;
					guiUpdater.setMenu(menuNum);
					guiUpdater.updateMenu(1,0,0);
				}
			}
		} else {
			if (menuNum == 0) {
				int lType = menuPosX;
				menuNum = 1+lType;
				menuPosX = 0;
				menuPosY = 0;
				guiUpdater.setMenu(menuNum);
				guiUpdater.updateMenu(0,0,0);
			} else if (menuNum < 6) {
				type = menuNum-1;
				if (player.getLevelDone(type, 10*menuPosY+menuPosX) == 0) return;
				player.setLongestSnake(level.getType(), level.getLevelNum(), level.getNumApples());
				player.setLastMod(type);
				player.savePlayer();
				loadLevel(10*menuPosY+menuPosX);
				gameLoop.setPaused(false);
			}
		}
	}
	private void setFocusToGame() {
		cGame.requestFocus();
	}
	
	private void setType(int t) {
		if ((gameLoop != null) && gameLoop.getPaused()) return;
		type = t;
		
		lev = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[type] ; i++) {
			if (player.getLevelDone(type, i) == 1) {
				lev = i;
				break;
			}
		}
	}
	private void loadLevel(int num) {
		if (num >= Globals.NUM_LEVELS[type]) return;
		if (player.getLevelDone(type, num) == 0) return;
		level = JSLevel.loadLevel("res/levels/level"+Integer.toString(type)+"_"+Integer.toString(num)+".js7l");
		Snake s = new Snake(Coord.getZeroCoord());
		s.place(level);
		if (t != null) t.cancel();
		
		cGame.requestFocus();
		guiUpdater.setLevel(level);
		guiUpdater.setSnake(s);
		
		gameLoop = new GameLoop(level, s, guiUpdater, player);
		guiUpdater.drawLevel();
		
		t = new Timer();
		t.schedule(gameLoop, 0, 250);
	}
	
	private void loadLevel() {
		loadLevel(lev);
	}
	
	private void turn(int dx, int dy) {
		int maxY = 4;
		if (menuNum == 2) maxY = 9;
		if (gameLoop == null) return;
		if (gameLoop.getPaused()) {
			menuPosX+=dx;
			menuPosY+=dy;
			if (menuNum == 0) {
				if (menuPart == 0) {
					if (menuPosX < 0) menuPosX = 4;
					if (menuPosX > 4) menuPosX = 0;
					lastPosX = menuPosX;
				} else if (menuPart == 1) {
					if (menuPosX < 0) menuPosX = 1;
					if (menuPosX > 1) menuPosX = 0;
				}
				
				if (menuPosY != 0) {
					menuPart = 1-menuPart;
					menuPosY = 0;
					menuPosX = 0;
					if (menuPart == 0) menuPosX = lastPosX;
				}
			} else if (menuNum < 6) {
				if (menuPart == 0) {
					if (menuPosX < 0) menuPosX = 9;
					if (menuPosX > 9) menuPosX = 0;
					lastPosX = menuPosX;
					
					if ((menuPosY < 0) || (menuPosY > maxY)) {
						menuPosY = 0;
						menuPosX = 1;
						menuPart = 1;
					}
				} else if (menuPart == 1) {
					if (menuPosX != 1) menuPosX = 1;
					
					if (menuPosY < 0) {
						menuPosY = maxY;
						menuPosX = lastPosX;
						menuPart = 0;
					} else if (menuPosY > 0) {
						menuPosY = 0;
						menuPosX = lastPosX;
						menuPart = 0;
					}
				}
			} else if (menuNum == 6) {
				menuPart = 1;
				menuPosX = 1;
				menuPosY = 0;
			}
			guiUpdater.updateMenu(menuPart, menuPosX, menuPosY);
		} else {
			gameLoop.setDir(new Coord(dx,dy,0));
		}
	}
	
	private void drawGame() {
		if (guiUpdater != null) guiUpdater.showGame();
	}
	
	private void drawHud() {
		if (guiUpdater != null) guiUpdater.showHud();
	}
	
}