/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
 import java.util.Vector;

class SnakeBody {
	private Vector<SnakeElement> elements;
	private SnakeElement curElem;
	
	public SnakeBody() {
		elements = new Vector<SnakeElement>();
		curElem = null;
	}
	
	public void move(Coord headPos) {
		if (curElem == null) return;
		curElem.setPos(headPos);
		curElem = curElem.getNext();
	}
	
	public void addElement(Coord pos) {
		if (curElem == null) {
			elements.add(new SnakeElement(pos, 1));
			curElem = elements.elementAt(0);
		} else {
			elements.add(new SnakeElement(pos,curElem, 1));
			curElem = curElem.getPrev();
		}
	}
	
	public void setCurTexture(int text) {
		if (curElem != null)
			curElem.setTexture(text);
	}
	public Coord getPos() {
		if (curElem != null)
			return curElem.getPos();
		else return null;
	}
	
	public Coord getPrevPos() {
		if (curElem != null)
			return curElem.getPrev().getPos();
		else return null;
	}
	
	public Coord getNextPos() {
		if (curElem != null)
			return curElem.getNext().getPos();
		else return null;
	}
	
	public Vector<SnakeElement> getSnakeElements() {
		return elements;
	}
}