/*(c) JippySnake7 Developmentteam.
 *
 *
 * This code is published unter GNU Public Licence v2.
 *
 *
 */
 import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferStrategy;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JLabel;

import java.util.Timer;
import java.util.TimerTask;

class StatWindow extends JFrame {
	private JPanel pInfo;
	private JLabel lTextDone;
	private Canvas cStatBar;
	private Player player;
	private boolean isClosed = false;
	
	private class reDrawer extends TimerTask {
		private Canvas cStatCar;
		private Player player;
		private BufferStrategy buffStr;
		public reDrawer(Canvas c, Player p) {
			cStatBar = c;
			player = p;
			cStatBar.createBufferStrategy(2);
			buffStr = cStatBar.getBufferStrategy();
		}
		public void run() {
			int numDone = 0;
			for (int i = 0; i < Globals.NUM_LEVELS[0]; i++)
				if (player.getLevelDone(0,i) > 1) numDone++;
			for (int i = 0; i < Globals.NUM_LEVELS[1]; i++)
				if (player.getLevelDone(1,i) > 1) numDone++;
			for (int i = 0; i < Globals.NUM_LEVELS[2]; i++)
				if (player.getLevelDone(2,i) > 1) numDone++;
			for (int i = 0; i < Globals.NUM_LEVELS[3]; i++)
				if (player.getLevelDone(3,i) > 1) numDone++;
			for (int i = 0; i < Globals.NUM_LEVELS[4]; i++)
				if (player.getLevelDone(4,i) > 1) numDone++;
			int numToDo = Globals.NUM_LEVELS[0]+Globals.NUM_LEVELS[1]+Globals.NUM_LEVELS[2]+Globals.NUM_LEVELS[3]+Globals.NUM_LEVELS[4];
			int statSize = (int) cStatBar.getSize().getWidth();
			int statHeight = (int) cStatBar.getSize().getHeight();
			int drawWidth = (int) (numDone*((statSize+0.0)/(numToDo+0.0)));
			float green = (float) (numDone*(1.0/numToDo+0.0));
			float red = 1.0f-green;
			Graphics g = buffStr.getDrawGraphics();
			g.setColor(Color.BLACK);
			g.fillRect(0,0,statSize,statHeight);
			g.setColor(new Color(red,green,0.0f));
			g.fillRect(0,0,drawWidth,statHeight);
			try {
				buffStr.show();
			} catch (Exception e) {
			}
		}
	}
	public StatWindow(Player p) {
		setTitle("Jippy Snake 7 - Statistik");
		setResizable(false);
		
		int numDone;
		player = p;
		pInfo = new JPanel();
		pInfo.setLayout(new GridLayout(6,2));
		lTextDone = new JLabel("Level geschafft: ");
		pInfo.add(lTextDone);
		pInfo.add(new JLabel("Filles: "));
		
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[0]; i++)
			if (player.getLevelDone(0,i) > 1) numDone++;
		pInfo.add(new JLabel("Classic: "+numDone+" / "+Globals.NUM_LEVELS[0]));
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[0]; i++)
			if (player.getLevelDone(0,i) > 2) numDone++;
		pInfo.add(new JLabel("Classic: "+numDone+" / "+Globals.NUM_LEVELS[0]));
		
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[2]; i++)
			if (player.getLevelDone(2,i) > 1) numDone++;
		pInfo.add(new JLabel("Vielfrass: "+numDone+" / "+Globals.NUM_LEVELS[2]));
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[2]; i++)
			if (player.getLevelDone(2,i) > 2) numDone++;
		pInfo.add(new JLabel("Vielfrass: "+numDone+" / "+Globals.NUM_LEVELS[2]));
		
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[3]; i++)
			if (player.getLevelDone(3,i) > 1) numDone++;
		pInfo.add(new JLabel("Verwelken: "+numDone+" / "+Globals.NUM_LEVELS[3]));
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[3]; i++)
			if (player.getLevelDone(3,i) > 2) numDone++;
		pInfo.add(new JLabel("Verwelken: "+numDone+" / "+Globals.NUM_LEVELS[3]));
		
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[4]; i++)
			if (player.getLevelDone(4,i) > 1) numDone++;
		pInfo.add(new JLabel("Blind-Snake: "+numDone+" / "+Globals.NUM_LEVELS[4]));
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[4]; i++)
			if (player.getLevelDone(4,i) > 2) numDone++;
		pInfo.add(new JLabel("Blind-Snake: "+numDone+" / "+Globals.NUM_LEVELS[4]));
		
		numDone = 0;
		for (int i = 0; i < Globals.NUM_LEVELS[1]; i++)
			if (player.getLevelDone(1,i) > 1) numDone++;
		pInfo.add(new JLabel("Fressen: "+numDone+" / "+Globals.NUM_LEVELS[1]));
		pInfo.add(new JLabel("UltraSnakes: "+player.getNumUltraSnakes()));
		
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				close();
			}
		});
		cStatBar = new Canvas();
		cStatBar.setPreferredSize(new Dimension(300,20));
		setLayout(new BorderLayout());
		add(pInfo, BorderLayout.NORTH);
		add(cStatBar, BorderLayout.SOUTH);
		pack();
		setVisible(true);
		new Timer().schedule(new reDrawer(cStatBar, player),0,100);
	}
	public boolean isClosed() {
		return isClosed;
	}
	
	private void close() {
		isClosed = true;
		setVisible(false);
	}
}